%global pkg mellanox
%global kernel 4.19.91-27.8.an8
%define pkg_version 23.10
%define anolis_release 1
%define debug_package %{nil} 
%undefine _hardened_build
%global VAR1 CONFIG_AUXILIARY_BUS
%global VAR2 CONFIG_AUXILIARY_BUS_MODULE
# %global KERNEL_CONFIG_AUXILIARY_BUS %(tac /usr/src/kernels/%{kernel}.%{_arch}/include/*/autoconf.h | grep -m1 %{VAR1} |  awk '{print $3}')
# %{!?KERNEL_CONFIG_AUXILIARY_BUS: %global KERNEL_CONFIG_AUXILIARY_BUS %(tac /usr/src/kernels/%{kernel}.%{_arch}/include/*/autoconf.h | grep -m1 %{VAR2} |  awk '{print $3}')}
%global KERNEL_CONFIG_AUXILIARY_BUS 1
Name:        kmod-%{pkg}
Version:     %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:     %{pkg_version}~%{anolis_release}%{?dist}
Summary:     Mellanox NIC drivers
License:     GPL-v2
Source0:     kmod-%{pkg}-%{pkg_version}.tar.gz

Requires: kmod
Requires: dracut
BuildRequires: kernel-devel  = %{kernel}
BuildRequires: gcc kmod elfutils-libelf-devel automake

Provides: kmod-%{pkg}-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-%{pkg}-%{kernel}.%{_arch} < %{version}-%{release}
Provides: kmod-mellanox-ethernet-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-mellanox-ethernet-%{kernel}.%{_arch} < %{version}-%{release}

%description
Mellanox(R) NIC adapters 25G

%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

%build
#cd mlnx-ofa_kernel-%{pkgversion}/
cd src
./configure --kernel-version=%{kernel}.%{_arch} --kernel-sources=/usr/src/kernels/%{kernel}.%{_arch} \
    --build-dummy-mods --with-core-mod --with-user_mad-mod --with-user_access-mod \
    --with-addr_trans-mod --with-mlx5-mod --with-mlxfw-mod --with-ipoib-mod --without-xdp -j32
make -j32

%install
cd src
make install INSTALL_MOD_PATH=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/infiniband/
cp ofed_scripts/vf-net-link-name.sh $RPM_BUILD_ROOT/etc/infiniband/
mkdir -p $RPM_BUILD_ROOT/lib/udev/rules.d
cp ofed_scripts/82-net-setup-link.rules $RPM_BUILD_ROOT/lib/udev/rules.d/

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Generate depmod.conf
%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

# Generate kmod-mellanox-ethernet depmod.conf
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/compat/ -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/mlnx-ofa_kernel/compat/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
    echo "override $(basename $kmod .ko) * extra/mlnx-ofa_kernel/compat/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
done

for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/net/ethernet/ -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/mlnx-ofa_kernel/drivers/net/ethernet/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
    echo "override $(basename $kmod .ko) * extra/mlnx-ofa_kernel/drivers/net/ethernet/(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
done

for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/net/mlxdevm/ -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/mlnx-ofa_kernel/net/mlxdevm/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
    echo "override $(basename $kmod .ko) * extra/mlnx-ofa_kernel/net/mlxdevm/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
done

for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/base/ -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/mlnx-ofa_kernel/drivers/base/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
    echo "override $(basename $kmod .ko) * extra/mlnx-ofa_kernel/drivers/base/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf
done

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    dracut -f --kver "$kversion" > /dev/null 2>&1
done

find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' | weak-modules --no-initramfs --add-modules > /dev/null 2>&1

%preun
for module in `find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' -o -name '*.ko.gz' | sort`
do
	echo "$module" >> /var/run/rpm-%{pkg}-modules.list
done

%postun
/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    dracut -f --kver "$kversion" > /dev/null 2>&1
done

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules > /dev/null 2>&1
fi
rm /var/run/rpm-%{pkg}-modules.list

%files
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/*
%exclude /lib/modules/%{kernel}.%{_arch}/modules.alias
%exclude /lib/modules/%{kernel}.%{_arch}/modules.symbols
%exclude /lib/modules/%{kernel}.%{_arch}/modules.softdep
%exclude /lib/modules/%{kernel}.%{_arch}/modules.devname
%exclude /lib/modules/%{kernel}.%{_arch}/modules.dep
%exclude /lib/modules/%{kernel}.%{_arch}/modules.symbols.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.builtin.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.dep.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.alias.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.builtin.alias.bin
/etc/infiniband/openib.conf
/etc/init.d/openibd
/etc/modprobe.d/mlnx.conf
/etc/modprobe.d/ib_ipoib.conf
/usr/sbin/setup_mr_cache.sh
/etc/infiniband/mlx5.conf
/etc/infiniband/vf-net-link-name.sh
/etc/modprobe.d/mlnx-bf.conf
/usr/sbin/ibdev2netdev
/lib/udev/auxdev-sf-netdev-rename
/lib/udev/rules.d/82-net-setup-link.rules
/lib/udev/rules.d/83-mlnx-sf-name.rules
/lib/udev/rules.d/90-ib.rules
/lib/udev/sf-rep-netdev-rename
/usr/share/mlnx_ofed/mlnx_bf_assign_ct_cores.sh
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf


%package -n  kmod-mellanox-ethernet
Summary: kmod-mellanox-ethernet package
%description -n kmod-mellanox-ethernet
kmod-mellanox-ethernet package



%post -n  kmod-mellanox-ethernet
/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    dracut -f --kver "$kversion" > /dev/null 2>&1
done

find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' | weak-modules --no-initramfs --add-modules > /dev/null 2>&1
%preun  -n  kmod-mellanox-ethernet
for module in `find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' -o -name '*.ko.gz' | sort`
do
        echo "$module" >> /var/run/rpm-kmod-mellanox-ethernet-modules.list
done
%postun -n  kmod-mellanox-ethernet

/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    dracut -f --kver "$kversion" > /dev/null 2>&1
done

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-kmod-mellanox-ethernet-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules > /dev/null 2>&1
fi
rm /var/run/rpm-kmod-mellanox-ethernet-modules.list

%files -n kmod-mellanox-ethernet
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/compat/*
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/net/ethernet/*
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/net/mlxdevm/*
%if "%{KERNEL_CONFIG_AUXILIARY_BUS}" != "1"
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/drivers/base/*
%endif
%dir /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}-ethernet.conf

%changelog
* Thu May 26 2022 lq.hj <lq.h@alibaba-inc.com> - 5.8
- mellanox driver 5.8 build for 5.10.134-15.1.an8
